Summary: Generic linux kernel
Name: kernel
Version: 2.0.32
%define version %{PACKAGE_VERSION}
%define pcmciaver 2.9.12
Release: 2
Copyright: GPL
Group: Base/Kernel
ExclusiveArch: i386
ExclusiveOS: Linux
Source: ftp://hyper.stanford.edu/pub/pcmcia/pcmcia-cs-%pcmciaver.tar.gz
Source1: ftp://ftp.kernel.org/pub/linux/kernel/v2.0/linux-%{version}.tar.gz
Source2: kernel-config.i386
Source3: pcmcia-cs-2.8.8-network.script
Source4: ftp://gear.torque.net/pub/bpcd.c
Source5: module-info
Source6: kernel-config.axp
Source8: installkernel
Source11: de4x5.c
Source12: de4x5.h
Patch: kernel-make.patch
Patch2: axp-diffs-2.0.31.patch
Patch6: linux-2.0.30-alphamachines.patch.gz
Patch7: linux-2.0.30-freemem.patch
Patch9: linux-2.0.30-sound-16.patch
Patch10: linux-2.0.30-include.patch
Patch11: pcmcia-cs-2.9.10-glibc.patch
Patch16: 3c59x-busmaster.patch
BuildRoot: /var/tmp/kernel
Provides: module-info
Autoreqprov: no
Requires: initscripts >= 3.0

%changelog

* Tue Nov 18 1997 Erik Troan <ewt@redhat.com>

- upgraded to 2.0.32
- release 2 is for 5.0, release 1 is for 4.x (and doesn't include modular
  sound)
- updated pcmcia stuff to 2.9.12

* Sun Nov 09 1997 Erik Troan <ewt@redhat.com>

- added patch from davem for IP fragments w/ bad sizes
- uses 2.0.30 de4x5 driver
- don't try to do pcmcia stuff on non-intel boxes

* Sat Nov 08 1997 Erik Troan <ewt@redhat.com>

- updated axp-diffs for 2.0.31

* Fri Nov 07 1997 Mike Wangsmo <wanger@redhat.com>

- fixed sound patch for monolythic kernesl (again) 

* Wed Nov 05 1997 Mike Wangsmo <wanger@redhat.com>

- fixed sound patch

* Mon Nov 03 1997 Erik Troan <ewt@redhat.com>

- turned on masq, multicast

* Fri Oct 31 1997 Erik Troan <ewt@redhat.com>

- added *piles* of patches from cox and fink
- updated eepro100 and 3x59x drivers
- updated to sound-14 patch

* Mon Oct 27 1997 Erik Troan <ewt@redhat.com>

- added patches from Ingo 
* Tue Oct 21 1997 Erik Troan <ewt@redhat.com>

- updated to 2.0.31 kernel
- updated to 2.9.11 pcmcia-cs

* Mon Oct 06 1997 Erik Troan <ewt@redhat.com>

- updated pcmcia network script for new initscripts
- turned on /dev/rtc

* Mon Sep 29 1997 Michael K. Johnson <johnsonm@redhat.com>

- Updated to pre-10...
- Removed our separate eepro100 driver since one is now included.
- Removed our newer 3c59x driver, as the one in the kernel has been updated.
- Updated pcmcia to 2.9.10, removed omega and include pcmcia patches.

* Mon Sep 08 1997 Mike Wangsmo <wanger@redhat.com>

- ISDN people are among the folks who can't figure out that the kernel
  isn't supposed to be using system header files like stdio.h

- Upgraded to Linus' final pre31 patch (pre2.0.31-9)  This _should_
  be the same as 2.0.31

- Moved to linux-2.0.30-sound-12 which fixed some problems SoundScape
  cards and with the Trix stuff.  Also ifarch'd the sound stuff
  build so that it only gets built on the Intel's.

* Wed Aug 27 1997 Michael K. Johnson <johnsonm@redhat.com>

- Fixed Alan's sound patch to compile with the new, fixed genksyms

* Mon Aug 18 1997 Michael K. Johnson <johnsonm@redhat.com>

- Moved to pre-2.0.31-7 from Linus
- removed netalias patch for -7
- removed one line from ne2000 patch that wouldn't compile.

* Thu Aug 14 1997 Mike Wangsmo <wanger@redhat.com>

- Applied linux-2.0.30-sound-10.patch.
- Included sound readme in kernel/drivers/sound

* Tue Aug 12 1997 Michael K. Johnson <johnsonm@redhat.com>

- Moved to pre-2.0.31-5 from Linus
- Created netalias patch for fix in -5, omega patch for pcmcia-cs
- No longer need smallncr patch; included in -5

* Tue Aug 05 1997 Michael K. Johnson <johnsonm@redhat.com>

- Moved to pre-2.0.31-3 from Linus

* Tue Jun 03 1997 Erik Troan <ewt@redhat.com>

- updated to pre-2.0.31-2

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>

- Added linux-2.0.30-freemem.patch patch

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>

- Added /usr/include/linux, /usr/include/asm, and /usr/include/scsi symlinks
  to this package.
- Added default /sbin/installkernel (thanks to Tyson Sawyer)

%package source
Requires: kernel-headers = %{version}
Summary: Kernel source tree
Group: Base/Kernel

%package modules
Summary: Collection of kernel modules
Group: Base/Kernel
%ifarch i386
Requires: kernel = %{version}
%endif

%package -n pcmcia-cs
Requires: kernel = %{version}
Summary: Daemon and device drivers for using PCMCIA adapters
Group: Daemons
Version: %pcmciaver

%package headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%description -n pcmcia-cs
Many laptop machines (and some others) support PCMCIA cards for expansion. 
Also known as "credit card adapters", PCMCIA cards are small cards for
everything from SCSI support to modems. They are hot swappable (they can
be exchanged without rebooting the system) and quite convienent. This package
contains support for numerous PCMCIA cards of all varieties and supplies a
daemon which allows them to be hot swapped.

%description headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%prep
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%setup -c -q
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/src/
cd $RPM_BUILD_ROOT/usr/src
tar xzf $RPM_SOURCE_DIR/linux-%{version}.tar.gz
chown -R 0.0 linux

mv linux linux-%{version}
ln -sfn linux-%{version} linux

cd linux-%{version}

%patch0 -p1

# The 2.0.32 de4x5 driver doesn't do 100MB 
rm drivers/net/de4x5.c
cp $RPM_SOURCE_DIR/de4x5.c drivers/net/de4x5.c
rm drivers/net/de4x5.h
cp $RPM_SOURCE_DIR/de4x5.h drivers/net/de4x5.h

%patch16 -p1

%ifarch alpha
%patch2 -p1 -b .axpdiffs
#%patch6 -p1 -b .axpmachines
find include -name "*.axpdiffs" | xargs rm
#find include -name "*.axpmachines" | xargs rm
%endif

# Build the sound modules ONLY on Intels
%ifarch i386
%patch9 -p1 
%endif

# isdn folks think stdio.h is an appropriate include file in the kernel...
%patch10 -p1 -b .include

%ifarch i386
cp $RPM_SOURCE_DIR/kernel-config.i386 arch/i386/defconfig
%endif
%ifarch alpha
cp $RPM_SOURCE_DIR/kernel-config.axp arch/alpha/defconfig
%endif

# We do this in %prep to let the pcmcia stuff get configured properly
make oldconfig
make dep

# now setup pcmcia stuff back in the build directory
cd $RPM_BUILD_DIR/kernel-%version
cd pcmcia-cs-%pcmciaver
# apply any pcmcia patches
%patch11 -p2 -b .glibc

make config <<EOF
$RPM_BUILD_ROOT/usr/src/linux
$RPM_BUILD_ROOT


$RPM_OPT_FLAGS
2
y
/etc/rc.d
EOF
cd ..
mkdir -p extra
cd extra
cp $RPM_SOURCE_DIR/bpcd.c .
cd ..

# this is stupid, but pcmcia needs /usr/include/linux to point to the
# proper kernel sources
for n in linux asm scsi; do
    rm -f /usr/include/$n
    ln -sf $RPM_BUILD_ROOT/usr/src/linux/include/$n /usr/include/$n
done

%build
cd $RPM_BUILD_ROOT/usr/src/linux-%{version}
make include/linux/version.h

%ifarch i386
# we don't actually build a kernel package on the Alpha

make boot
make modules

# now for the extra modules CD driver
cd $RPM_BUILD_DIR/kernel-%{version}/extra
gcc -I$RPM_BUILD_ROOT/usr/src/linux/include -D__KERNEL__ -DMODULE -DMODVERSIONS -include $RPM_BUILD_ROOT/usr/src/linux/include/linux/modversions.h -O2 -c bpcd.c

cd $RPM_BUILD_DIR/kernel-%{version}/pcmcia-cs-%pcmciaver
make all
%endif

%install

mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -s ../src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

%ifarch i386
mkdir -p $RPM_BUILD_ROOT/sbin
install -m 755  $RPM_SOURCE_DIR/installkernel $RPM_BUILD_ROOT/sbin/installkernel
%endif

cd $RPM_BUILD_ROOT/usr/src/linux-%{version}
mkdir -p $RPM_BUILD_ROOT/boot
cp $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-%{version}

%ifarch i386
cp System.map $RPM_BUILD_ROOT/boot/System.map-%{version}
cp arch/i386/boot/zImage $RPM_BUILD_ROOT/boot/vmlinuz-%{version}
ln -sf vmlinuz-%{version} $RPM_BUILD_ROOT/boot/vmlinuz
%endif

mkdir -p $RPM_BUILD_ROOT/lib/modules

%ifarch i386
make PREFIX=$RPM_BUILD_ROOT modules_install
cp $RPM_BUILD_DIR/kernel-%{version}/extra/bpcd.o $RPM_BUILD_ROOT/lib/modules/%{version}/cdrom
%endif

cd $RPM_BUILD_ROOT/usr/src/linux-%{version}

# keep kernel-source archive clean
make mrproper
make oldconfig
make symlinks
make include/linux/version.h

# this generates modversions info which we want to include and we may as
# well include the depends stuff as well
make depend

# this is dumb :-)
make -C scripts/lxdialog all

%ifarch i386 
mkdir -p $RPM_BUILD_ROOT/etc/pcmcia
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig

cd $RPM_BUILD_DIR/kernel-%{version}/pcmcia-cs-%pcmciaver
make install

# Install our own network up/down script
install -m755 $RPM_SOURCE_DIR/pcmcia-cs-2.8.8-network.script \
        $RPM_BUILD_ROOT/etc/pcmcia/network

# We need our own default /etc/sysconfig/pcmcia
echo PCMCIA=no > $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo PCIC= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia 
echo PCIC_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia
echo CORE_OPTS= >> $RPM_BUILD_ROOT/etc/sysconfig/pcmcia

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc0.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc2.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc3.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc5.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/rc6.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d

mv $RPM_BUILD_ROOT/etc/rc.d/rc.pcmcia $RPM_BUILD_ROOT/etc/rc.d/init.d/pcmcia

# We use different default sequence numbers
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc0.d/K52pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc2.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc3.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc5.d/S45pcmcia
ln -sf ../init.d/pcmcia $RPM_BUILD_ROOT/etc/rc.d/rc6.d/K52pcmcia

# Finally strip some binaries
cd $RPM_BUILD_ROOT/sbin
strip cardmgr cardctl probe scsi_info ftl_format ftl_check
%endif

# put /usr/include/linux back
for n in linux asm scsi; do
    rm -f /usr/include/$n
    ln -sf ../src/linux/include/$n /usr/include/$n
done

%clean
if [ "X" != "${RPM_BUILD_ROOT}X" ]; then
    rm -rf $RPM_BUILD_ROOT
fi

%post
cd /boot
ln -sf vmlinuz-%{version} vmlinuz
ln -sf System.map-%{version} System.map
ln -sf module-info-%{version} module-info

if [ -x /sbin/lilo -a -f /etc/lilo.conf ]; then
	/sbin/lilo > /dev/null
fi

%post headers
cd /usr/src
ln -snf linux-%{version} linux

%post source
cd /usr/src
ln -snf linux-%{version} linux

%postun headers

if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{version}" ]; then
	rm -f /usr/src/linux
    fi
fi

%preun modules
if [ `uname -r` = "%{version}" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi

%ifarch i386
%files
/boot/vmlinuz-*
/boot/System.map-%{version}
/boot/module-info-%{version}
/sbin/installkernel
%endif

%files source
%dir /usr/src/linux-%{version}
/usr/src/linux-%{version}/COPYING
/usr/src/linux-%{version}/CREDITS
/usr/src/linux-%{version}/Documentation
/usr/src/linux-%{version}/MAINTAINERS
/usr/src/linux-%{version}/Makefile
/usr/src/linux-%{version}/Makefile.orig
/usr/src/linux-%{version}/README
/usr/src/linux-%{version}/Rules.make
/usr/src/linux-%{version}/arch
/usr/src/linux-%{version}/drivers
/usr/src/linux-%{version}/fs
/usr/src/linux-%{version}/init
/usr/src/linux-%{version}/ipc
/usr/src/linux-%{version}/kernel
/usr/src/linux-%{version}/lib
/usr/src/linux-%{version}/mm
/usr/src/linux-%{version}/modules
/usr/src/linux-%{version}/net
/usr/src/linux-%{version}/scripts

%ifarch i386
%files modules
%dir /lib/modules
%dir /lib/modules/%{version}
/lib/modules/%{version}/scsi
/lib/modules/%{version}/net
/lib/modules/%{version}/block
/lib/modules/%{version}/cdrom
/lib/modules/%{version}/fs
/lib/modules/%{version}/misc
/lib/modules/%{version}/ipv4
%endif

%ifarch i386 
%files -n pcmcia-cs
%doc pcmcia-cs-%pcmciaver/doc/PCMCIA-HOWTO 
%doc pcmcia-cs-%pcmciaver/SUPPORTED.CARDS 
%doc pcmcia-cs-%pcmciaver/CHANGES 
%doc pcmcia-cs-%pcmciaver/COPYING 
%doc pcmcia-cs-%pcmciaver/README
/lib/modules/%{version}/pcmcia

/sbin/cardctl
/sbin/cardmgr
/sbin/ftl_check
/sbin/ftl_format
/sbin/ide_info
/sbin/ifport
/sbin/pcinitrd
/sbin/probe
/sbin/scsi_info

/usr/man/*/*

/etc/rc.d/rc0.d/K52pcmcia
/etc/rc.d/rc2.d/S45pcmcia
/etc/rc.d/rc3.d/S45pcmcia
/etc/rc.d/rc5.d/S45pcmcia
/etc/rc.d/rc6.d/K52pcmcia

%config /etc/rc.d/init.d/pcmcia
%config /etc/sysconfig/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/config
/etc/pcmcia/cdrom
/etc/pcmcia/fixed
/etc/pcmcia/ftl
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/scsi
/etc/pcmcia/serial
/etc/pcmcia/shared

%config /etc/pcmcia/config.opts
%config /etc/pcmcia/cdrom.opts
%config /etc/pcmcia/fixed.opts
%config /etc/pcmcia/ftl.opts
%config /etc/pcmcia/memory.opts
%config /etc/pcmcia/scsi.opts
%config /etc/pcmcia/serial.opts
%endif

%files headers
/usr/src/linux-%{version}/include/asm
/usr/src/linux-%{version}/include/asm-generic
/usr/src/linux-%{version}/include/linux
/usr/src/linux-%{version}/include/net
/usr/src/linux-%{version}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/include/scsi

%ifarch alpha
/usr/src/linux-%{version}/include/asm-alpha
%endif

%ifarch i386
/usr/src/linux-%{version}/include/asm-i386
%endif

%ifarch sparc
/usr/src/linux-%{version}/include/asm-sparc
%endif
